(*==========================================================================
 * The type signatures in this file were automatically generated from the 
 * implementation.  Documentation (c) Microsoft Corporation 2004.
 *
 * All code and documentation in the interface and implementation of 
 * this module has been written 'from scratch'.  The interface to the module 
 * is similar to that found in versions of other ML implementations, 
 * but is not an exact match.  The type signatures in this interface
 * are an edited version of those generated automatically by running 
 * "bin\fsc.exe -i" on the implementation file.
 *=========================================================================*)

(*==========================================================================
 * Psuedo-polymorphic 2-dimensional arrays.
 *
 * For any particular 'a , the "'a[]" type is type-compatible with 
 * the corresponding C# 2-dimensional array type. The module contains
 * operations to manipulate these values.  The operations may be used 
 * on any version of the .NET CLR.  See the 'Advanced' section of 
 * the manual for when 'Compatibility' array operations are needed to write
 * code that will function on any version of the CLR.
 *
 * See the sample fsharp/Automation/Excel for an example of passing one of
 * these values to fill in the cells of an Excel spreadsheet.
 *
 * Multi-dimensional array types do not support polymorphic
 * comparison operations (Pervasives.compare etc.) in this release.
 *=========================================================================*)

module Microsoft.FSharp.Compatibility.CompatMatrix

#if GENERICS
val create: int -> int -> 'a -> 'a[,]
val get: 'a[,] -> int -> int -> 'a
val init: int -> int -> (int -> int -> 'a) -> 'a[,]
val iter: ('a -> unit) -> 'a[,] -> unit
val iteri: (int -> int -> 'a -> unit) -> 'a[,] -> unit
val length1: 'a[,] -> int
val length2: 'a[,] -> int
val make: int -> int -> 'a -> 'a[,]
val map: ('a -> 'b) -> 'a[,] -> 'b[,]
val mapi: (int -> int -> 'a -> 'b) -> 'a[,] -> 'b[,]
val set: 'a[,] -> int -> int -> 'a -> unit
val zero_create: int -> int -> 'a[,]

#else

val inline create: int -> int -> $a -> $a[,]
val inline get: $a[,] -> int -> int -> $a
val inline init: int -> int -> (int -> int -> $a) -> $a[,]
val inline iter: ($a -> unit) -> $a[,] -> unit
val inline iteri: (int -> int -> $a -> unit) -> $a[,] -> unit
val inline length1: $a[,] -> int
val inline length2: $a[,] -> int
val inline make: int -> int -> $a -> $a[,]
val inline map: ($a -> $b) -> $a[,] -> $b[,]
val inline mapi: (int -> int -> $a -> $b) -> $a[,] -> $b[,]
val inline set: $a[,] -> int -> int -> $a -> unit
val inline zero_create: int -> int -> $a[,]

#endif
