(* (c) Microsoft Corporation. All rights reserved *)

module Microsoft.FSharp.Primitives.ArrayPrimitives

(* Define the primitive operations. *)
(* Note: the "type" syntax is for the type parameter for inline *)
(* polymorphic IL. This helps the compiler inline these fragments, *)
(* i.e. work out the correspondence between IL and F# type variables. *)
let length (arr: 'a array) =  (# "ldlen" arr : int)  
let get (arr: 'a array) (n:int) =  (# "ldelem.erasable !0" type ('a) arr n : 'a)  
let set (arr: 'a array) (n:int) (x:'a) =  (# "stelem.erasable !0" type ('a) arr n x)  
let zero_create (n:int) = (# "newarr.erasable !0" type ('a) n : 'a array)



