(*==========================================================================
 * This file contains the definitions of primitive operations which can
 * be used to implement a functional programming library for use with the
 * F# compiler.  They are not typically for direct use from user code.
 *
 * The original version of the type signatures in this file were
 * automatically generated from the implementation.  Documentation 
 * (c) Microsoft Corporation 2004.
 *=========================================================================*)

module Microsoft.FSharp.Primitives.Operators

val op_BooleanNegation: bool -> bool
val op_StructuralComparison: 'a -> 'a -> int32
val op_StructuralMaximum: 'a -> 'a -> 'a
val op_StructuralMinimum: 'a -> 'a -> 'a
val op_ArrayGet: 'a array -> int32 -> 'a
val op_ArraySet: 'a array -> int32 -> 'a -> unit
val op_Assign: Ref<'a> -> 'a -> unit
val op_Dereference: Ref<'a> -> 'a
val op_CreateReference: 'a -> Ref<'a>
val op_FloatAddition: float -> float -> float
val op_FloatDivision: float -> float -> float
val op_FloatExponentiation: float -> float -> float
val op_FloatMultiplication: float -> float -> float
val op_FloatNegation: float -> float
val op_FloatSubtraction: float -> float -> float
val op_StructuralHash: 'a -> int32
val op_StructuralEquality: 'a -> 'a -> bool
val op_StructuralGreaterThan: 'a -> 'a -> bool
val op_StructuralGreaterThanOrEqual: 'a -> 'a -> bool
val op_StructuralInequality: 'a -> 'a -> bool
val op_StructuralLessThan: 'a -> 'a -> bool
val op_StructuralLessThanOrEqual: 'a -> 'a -> bool

val op_GenericEq: 'a -> 'a -> bool
val op_GenericNotEq: 'a -> 'a -> bool

val op_IntegerAddition: int32 -> int32 -> int32
val op_IntegerDivision: int32 -> int32 -> int32
val op_IntegerMultiplication: int32 -> int32 -> int32
val op_IntegerNegation: int32 -> int32
val op_IntegerSubtraction: int32 -> int32 -> int32
val op_IntegerLogicalOr: int32 -> int32 -> int32
val op_IntegerLogicalXor: int32 -> int32 -> int32
val op_IntegerLogicalAnd: int32 -> int32 -> int32
val op_IntegerModulus: int32 -> int32 -> int32
val op_IntegerLogicalShiftLeft: int32 -> int32 -> int32
val op_IntegerLogicalShiftRight: int32 -> int32 -> int32
val op_IntegerArithmeticShiftRight: int32 -> int32 -> int32
val op_IntegerLogicalNot: int32 -> int32
val op_ListAppend: List<'a> -> List<'a> -> List<'a>
val op_StringConcatenation: string -> string -> string
val op_StringGet: string -> int32 -> char

val inline op_OverloadedAddition: ^a -> ^b -> ^a when ^a.op_Addition : (^a, ^b) -> ^a
val inline op_OverloadedSubtraction: ^a -> ^b -> ^a when ^a.op_Subtraction : (^a, ^b) -> ^a
val inline op_OverloadedMultiplication: ^a -> ^b -> ^a when ^a.op_Multiply : (^a, ^b) -> ^a
val inline op_OverloadedDivision: ^a -> ^b -> ^a when ^a.op_Division : (^a, ^b) -> ^a
val inline op_OverloadedModulus: ^a -> ^b -> ^a when ^a.op_Modulus : (^a, ^b) -> ^a

val inline op_OverloadedUnaryNegation: ^a -> ^a when ^a.op_UnaryNegation : (^a) -> ^a
val inline op_OverloadedUnaryPlus: ^a -> ^a when ^a.op_UnaryPlus : (^a) -> ^a
 
val inline op_OverloadedBitwiseAnd: ^a -> ^a -> ^a when ^a.op_BitwiseAnd : (^a,^a) -> ^a
val inline op_OverloadedBitwiseOr: ^a -> ^a -> ^a when ^a.op_BitwiseOr : (^a,^a) -> ^a
val inline op_OverloadedExclusiveOr: ^a -> ^a -> ^a when ^a.op_ExclusiveOr : (^a,^a) -> ^a
val inline op_OverloadedLogicalNot:  ^a -> ^a when ^a.op_LogicalNot : (^a) -> ^a

val inline op_OverloadedLeftShift: ^a -> int32 -> ^a when ^a.op_LeftShift : (^a,int32) -> ^a
val inline op_OverloadedRightShift: ^a -> int32 -> ^a when ^a.op_RightShift : (^a,int32) -> ^a
val inline op_OverloadedLogicalRightShift: ^a -> int32 -> ^a when ^a.op_RightShift : (^a,int32) -> ^a

(*--------------------------------------------------------------------------
 * Object Model Primitives
 *--------------------------------------------------------------------------*)


val inline op_Raise: (_ :> System.Exception) -> 'a
val op_Box: 'a -> System.Object
val op_Unbox: System.Object -> 'a


