(*==========================================================================
 * This file contains the definitions of primitive operations which can
 * be used to implement a functional programming library for use with the
 * F# compiler.  They are not typically for direct use from user code.
 *
 * LexBuffers are for use with automatically generated lexical analyzers,
 * in particular those produced by 'fslex'.
 *
 * (c) Microsoft Corporation 2004.
 *=========================================================================*)


(*--------------------------------------------------------------------------
 * Parsers generated by FsPars provide information from within parser
 * actions.  However that information is not available globally, but
 * rather is accessed via the functions available on the local
 * variable 
 *    parseInformation : Microsoft.FSharp.Primitives.ParserState.Provider
 *
 *--------------------------------------------------------------------------*)

module Microsoft.FSharp.Primitives.ParserState

type 'pos Provider = 
    { GetRhsStartMark: (int -> 'pos);
      GetRhsEndMark: (int -> 'pos);
      GetLhsStartMark: (unit -> 'pos);
      GetLhsEndMark: (unit -> 'pos);
      GetValue: (int -> obj);
      RaiseError: 'b. unit -> 'b  }

// Tables generated by fsyacc
type ('tok,'pos) tables = 
  { reductions: ('pos Provider -> obj) array ;
    end_of_input_tag: int;
    tagof: 'tok -> int;
    dataof: 'tok -> obj; 
    action_table_elements: byte[];
    action_table_row_offsets: byte[];
    reduction_nsyms: byte[];
    immediate_action: byte[];      
    gotos: byte[];
    gotos_row_offsets: byte[];
    nonterms: byte[];
    parse_error: string -> unit;
    tagof_error_term: int }

open Microsoft.FSharp.Primitives

// Engine for fsyacc
val InterpretTables : ('tok,'pos) tables -> (('pos,'char) Lexing.LexBuffer -> 'tok) -> ('pos,'char) Lexing.LexBuffer -> int -> obj
exception _FsParsAccept of obj
exception RecoverableParseError

val parse_error: string -> unit


