(*==========================================================================
 * The type signatures in this file were automatically generated from the 
 * implementation.  Documentation (c) Microsoft Corporation 2004.
 *
 * All code and documentation in the interface and implementation of 
 * this module has been written 'from scratch'.  The interface to the module 
 * is similar to that found in versions of other ML implementations, 
 * but is not an exact match.  The type signatures in this interface
 * are an edited version of those generated automatically by running 
 * "bin\fsc.exe -i" on the implementation file.
 *=========================================================================*)

module Microsoft.FSharp.Primitives.PrintfPrimitives

(* --------------------------------------------------------------------
 * 'format_one outa outc os fmt i cont'
 *  
 * Some format_one examples:
 *     's' --> :(string -> obj)
 *     'd' --> :(int -> obj)
 *     'a' --> :(obj -> ('b -> obj -> 'c) -> obj)
 *     't' --> :(obj -> obj)
 *     'f' --> :(float -> obj)
 * etc.
 *
 * The function 'cont' is called to produce the object that will be returned
 * after this part of the format is processed.
 * The function 'outa' is called to process the 'c values
 * returned by 'a' and 't' specifiers.
 * The function 'outc' is called to emit characters.
 * -------------------------------------------------------------------- *)

type ('a,'b,'c,'d) Format4 = Format4 of string * (obj -> 'a)
 
///A building block for processing format strings.  This processes the format character at
///the given position (which normally follows a '%' in a format
///string) and produces an 'obj' which can be dynamically cast to
///a type that depends on the format specifier. 
val format_one: ('c -> unit) -> (char -> unit) -> 'b -> string -> int -> (int -> obj) -> obj

val gprintf: ('c -> unit) -> (char -> unit) -> 'b -> (unit -> 'd) -> ('a,'b,'c,'d) Format4 -> 'a

