(* OCAML compatability bindings *)

module Microsoft.FSharp.MLLib.Big_int

open Microsoft.FSharp.Math.BigIntOps

  type big_int = Microsoft.FSharp.Math.BigInt
  
  val zero_big_int                    : big_int
  val unit_big_int                    : big_int
  val minus_big_int                   : big_int -> big_int -> big_int
(* abs_big_int *)    
  val add_big_int                     : big_int -> big_int -> big_int
  val succ_big_int                    : big_int -> big_int
  val add_int_big_int                 : int     -> big_int -> big_int
  val sub_big_int                     : big_int -> big_int -> big_int
  val pred_big_int                    : big_int -> big_int
  val mult_big_int                    : big_int -> big_int -> big_int
  val mult_int_big_int                : int     -> big_int -> big_int
  val square_big_int                  : big_int -> big_int
(* sqrt_big_int*)
  val quomod_big_int                  : big_int -> big_int -> big_int * big_int
  val div_big_int                     : big_int -> big_int -> big_int
  val mod_big_int                     : big_int -> big_int -> big_int
  val gcd_big_int                     : big_int -> big_int -> big_int
  val power_int_positive_int          : int     -> int -> big_int
  val power_big_int_positive_int      : big_int -> int -> big_int
  val power_int_positive_big_int      : int     -> big_int -> big_int
  val power_big_int_positive_big_int  : big_int -> big_int -> big_int
  val sign_big_int                    : big_int -> int
  val compare_big_int                 : big_int -> big_int -> int
  val eq_big_int                      : big_int -> big_int -> bool
  val le_big_int                      : big_int -> big_int -> bool
  val ge_big_int                      : big_int -> big_int -> bool
  val lt_big_int                      : big_int -> big_int -> bool
  val gt_big_int                      : big_int -> big_int -> bool
  val max_big_int                     : big_int -> big_int -> big_int
  val min_big_int                     : big_int -> big_int -> big_int
(* num_digits_big_int *)
  val string_of_big_int               : big_int -> string
  val big_int_of_string               : string  -> big_int
  val int_of_big_int                  : big_int -> int    
(* is_int_big_int *)
  val big_int_of_int                  : int     -> big_int
  val float_of_big_int                : big_int -> float
(* nat_of_big_int *)
(* big_int_of_nat *)
(* base_power_big_int *)
(* sys_big_int_of_string *)
(* round_futur_last_digit *)
(* approx_big_int *)    

