(*==========================================================================
 * Buffer: StringBuilder operations for ML compatibility
 *
 * This module is only included to make it possible to cross-compile 
 * code with other ML compilers.  It may be deprecated and/or removed in 
 * a future release. You may wish to functions in System.Text.StringBuilder 
 * instead. 
 *
 * (c) Microsoft Corporation 2004.  All code and documentation in this file 
 * has been written 'from scratch'.  The interface to the module 
 * is similar to that found in versions of other ML implementations, 
 * but is not an exact match.  The type signatures in this interface
 * are an edited version of those generated automatically by running 
 * "bin\fsc.exe -i" on the implementation file.
 *=========================================================================*)

module Microsoft.FSharp.MLLib.Buffer

type t = System.Text.StringBuilder
val add_buffer: t -> t -> unit
val add_char: t -> char -> unit
val add_string: t -> string -> unit
val add_substring: t -> string -> int -> int -> unit
val clear: t -> unit
val contents: t -> string
val create: int -> t
val length: t -> int
val output_buffer: out_channel -> t -> unit
val reset: t -> unit

(* Warning: this assumes an ASCII encoding for the I/O channel, i.e. it uses *)
(* Pervasives.really_input and then use ascii_to_string to produce the string *)
(* to add.  *)
val add_channel: t -> in_channel -> int -> unit
