(*==========================================================================
 * (c) Microsoft Corporation. All rights reserved 
 *
 * Bytes, range 0...255.  Compatible with the .NET "byte" type.  
 * The type "byte[]" is guaranteed to be compactly represented.
 *=========================================================================*)

module Microsoft.FSharp.MLLib.Byte

let compare (x:byte) y = Pervasives.compare x y

let zero = (# "ldc.i4 0" : byte) 
let one = (# "ldc.i4 1" : byte) 
let add (x:byte) (y:byte) = (# "add conv.u1" x y : byte) 
let sub (x:byte) (y:byte) = (# "sub conv.u1" x y : byte) 
let mul (x:byte) (y:byte) = (# "mul conv.u1" x y : byte)
let div (x:byte) (y:byte) = (# "div conv.u1" x y : byte)
let rem (x:byte) (y:byte) = (# "rem conv.u1" x y : byte)
let succ (x:byte) = (# "ldc.i4 1 add conv.u1" x : byte)
let pred (x:byte) = (# "ldc.i4 1 sub conv.u1" x : byte)
let logand (x:byte) (y:byte) = (# "and" x y : byte)
let logor (x:byte) (y:byte) = (# "or" x y : byte)
let logxor (x:byte) (y:byte) = (# "xor" x y : byte)
let lognot (x:byte) = (# "not" x : byte)
let shift_left (x:byte) (n:int) =  (# "shl conv.u1" x n : byte)
let shift_right (x:byte) (n:int) =  (# "shr conv.u1" x n : byte)
let shift_right_logical (x:byte) (n:int) =  (# "shr.un conv.u1" x n : byte)
let of_int (n:int) =  (# "conv.u1" n : byte)
let to_int (x:byte) = (# "" x : int)
let of_char (n:char) =  (# "conv.u1" n : byte)
let to_char (x:byte) = (# "" x : char)
let of_string (s:string) = 
  try System.Byte.Parse(s,System.Globalization.CultureInfo.InvariantCulture) 
  with :? System.FormatException -> failwith "Byte.of_string"
  
let to_string (x:byte) =  (box x).ToString()
			    
