(*==========================================================================
 * Bytes
 * 
 * (c) Microsoft Corporation 2004.  All code and documentation in this file 
 * has been written 'from scratch'.  The interface to the module 
 * is similar to that found in versions of other ML implementations, 
 * but is not an exact match.  The type signatures in this interface
 * are an edited version of those generated automatically by running 
 * "bin\fsc.exe -i" on the implementation file.
 *=========================================================================*)

module Microsoft.FSharp.MLLib.Byte

(*==========================================================================
 * Bytes, range 0...255.  Compatible with the .NET "byte" type.
 * The type "byte[]" is guaranteed to be compactly represented.
 *=========================================================================*)
 
val zero: byte
val one: byte
val succ: byte -> byte
val pred: byte -> byte

val add: byte -> byte -> byte
val div: byte -> byte -> byte
val mul: byte -> byte -> byte
val sub: byte -> byte -> byte
val rem: byte -> byte -> byte

val compare: byte -> byte -> int

val logand: byte -> byte -> byte
val lognot: byte -> byte
val logor: byte -> byte -> byte
val logxor: byte -> byte -> byte
val shift_left: byte -> int -> byte
val shift_right: byte -> int -> byte
val shift_right_logical: byte -> int -> byte

(* ASCII bytes <-> chars *)
val of_char: char -> byte
val to_char: byte -> char

val of_int: int -> byte
val to_int: byte -> int

val of_string: string -> byte
val to_string: byte -> string

