(* (c) Microsoft Corporation. All rights reserved *)

module Microsoft.FSharp.MLLib.Float

let add x y = x +. y
let div x y = x /. y
let mul x y = x *. y
let sub x y = x -. y
let neg x = -. x

let compare (x:float) y = Pervasives.compare x y

let of_int x = float_of_int x
let to_int x = int_of_float x

let of_int64 (x:int64) = (# "conv.r8" x : float)
let to_int64 (x:float) = (# "conv.i8" x : int64)

let of_int32 (x:int32) = (# "conv.r8" x : float)
let to_int32 (x:float) = (# "conv.i4" x : int32)

let of_float32 (x:float32) = (# "conv.r8" x : float)
let to_float32 (x:float) = (# "conv.r4" x : float32)

let to_string (x:float) = (box x).ToString()
let of_string x = float_of_string x

let of_bits x = Int64.float_of_bits x
let to_bits x = Int64.bits_of_float x


