(*==========================================================================
 * Float: ML-like operations on 64-bit System.Double floating point numbers.
 *
 * (c) Microsoft Corporation 2004.  All code and documentation in this file 
 * has been written 'from scratch'.  The interface to the module 
 * is similar to that found in versions of other ML implementations, 
 * but is not an exact match.  The type signatures in this interface
 * are an edited version of those generated automatically by running 
 * "bin\fsc.exe -i" on the implementation file.
 *=========================================================================*)

module Microsoft.FSharp.MLLib.Float

val add: float -> float -> float
val div: float -> float -> float
val mul: float -> float -> float
val neg: float -> float
val sub: float -> float -> float
val compare: float -> float -> int

val of_int: int -> float
val to_int: float -> int

val of_int32: int32 -> float
val to_int32: float -> int32

val of_int64: int64 -> float
val to_int64: float -> int64

val of_float32: float32 -> float
val to_float32: float -> float32

val of_string: string -> float
val to_string: float -> string

val of_bits: int64 -> float
val to_bits: float -> int64

