(* (c) Microsoft Corporation. All rights reserved *)

module Microsoft.FSharp.MLLib.Float32

let add (x:float32) (y:float32) = (# "add" x y : float32) 
let sub (x:float32) (y:float32) = (# "sub" x y : float32) 
let mul (x:float32) (y:float32) = (# "mul" x y : float32)
let div (x:float32) (y:float32) = (# "div" x y : float32)
let neg (x:float32) =  (# "neg" x : float32) 

let compare (x:float32) y = Pervasives.compare x y

let of_int (n:int) =  (# "conv.r4" n : float32)
let to_int (x:float32) = (# "conv.i4" x : int)

let of_int64 (x:int64) = (# "conv.r4" x : float32)
let to_int64 (x:float32) = (# "conv.i8" x : int64)

let of_int32 (x:int32) = (# "conv.r4" x : float32)
let to_int32 (x:float32) = (# "conv.i4" x : int32)

let of_float (x:float) = (# "conv.r4" x : float32)
let to_float (x:float32) = (# "conv.r8" x : float)

let to_string (x:float32) = (box x).ToString()
let of_string (s:string) = 
  try System.Single.Parse(s,System.Globalization.CultureInfo.InvariantCulture)
  with :? System.FormatException -> failwith "Float32.of_string"

let of_bits x = Int32.float32_of_bits x
let to_bits x = Int32.bits_of_float32 x


