(*==========================================================================
 * Float32: ML-like operations on 32-bit System.Single floating point numbers.
 *
 * (c) Microsoft Corporation 2004.  All code and documentation in this file 
 * has been written 'from scratch'.  The interface to the module 
 * is similar to that found in versions of other ML implementations, 
 * but is not an exact match.  The type signatures in this interface
 * are an edited version of those generated automatically by running 
 * "bin\fsc.exe -i" on the implementation file.
 *=========================================================================*)

module Microsoft.FSharp.MLLib.Float32

val add: float32 -> float32 -> float32
val div: float32 -> float32 -> float32
val mul: float32 -> float32 -> float32
val neg: float32 -> float32
val sub: float32 -> float32 -> float32
val compare: float32 -> float32 -> int

val of_int: int -> float32
val to_int: float32 -> int

val of_int32: int32 -> float32
val to_int32: float32 -> int32

val of_int64: int64 -> float32
val to_int64: float32 -> int64

val of_float: float -> float32
val to_float: float32 -> float

val of_string: string -> float32
val to_string: float32 -> string

val of_bits: int32 -> float32
val to_bits: float32 -> int32

