(*==========================================================================
 * Int64: Basic operations for ML compatibility
 *
 * (c) Microsoft Corporation 2004.  All code and documentation in this file 
 * has been written 'from scratch'.  The interface to the module 
 * is similar to that found in versions of other ML implementations, 
 * but is not an exact match.  The type signatures in this interface
 * are an edited version of those generated automatically by running 
 * "bin\fsc.exe -i" on the implementation file.
 *=========================================================================*)

module Microsoft.FSharp.MLLib.Int64

val zero: int64
val one: int64
val pred: int64 -> int64
val succ: int64 -> int64
val max_int: int64
val min_int: int64
val minus_one: int64

val abs: int64 -> int64
val add: int64 -> int64 -> int64
val div: int64 -> int64 -> int64
val mul: int64 -> int64 -> int64
val neg: int64 -> int64
val rem: int64 -> int64 -> int64
val sub: int64 -> int64 -> int64

val compare: int64 -> int64 -> int

val logand: int64 -> int64 -> int64
val lognot: int64 -> int64
val logor: int64 -> int64 -> int64
val logxor: int64 -> int64 -> int64
val shift_left: int64 -> int -> int64
val shift_right: int64 -> int -> int64
val shift_right_logical: int64 -> int -> int64

val of_float32: float32 -> int64
val to_float32: int64 -> float32

val of_float: float -> int64
val to_float: int64 -> float

(* Conversions to integers are to either the same size or same sign *)
val of_int: int -> int64
val to_int: int64 -> int

val of_int32: int32 -> int64
val to_int32: int64 -> int32

val of_uint64: uint64 -> int64
val to_uint64: int64 -> uint64

val of_nativeint: nativeint -> int64
val to_nativeint: int64 -> nativeint

val of_string: string -> int64
val to_string: int64 -> string

val float_of_bits: int64 -> float
val bits_of_float: float -> int64

