(* (c) Microsoft Corporation. All rights reserved *)

module Microsoft.FSharp.MLLib.Lazy

type 'a t = 'a Lazy

exception Undefined = Microsoft.FSharp.UndefinedException

let force_with_lock (x: 'a t) = Microsoft.FSharp.Primitives.LazyPrimitives.SynchronizedForce x
let force_without_lock (x: 'a t) = Microsoft.FSharp.Primitives.LazyPrimitives.Force x
let force (x: 'a t) = force_without_lock x
 
let force_val x = Microsoft.FSharp.Primitives.LazyPrimitives.Force x
let lazy_from_fun f = Microsoft.FSharp.Primitives.LazyPrimitives.FromFun f
let lazy_from_val v = Microsoft.FSharp.Primitives.LazyPrimitives.FromVal v
let lazy_is_val x = Microsoft.FSharp.Primitives.LazyPrimitives.IsVal x


