(*==========================================================================
 * (c) Microsoft Corporation. All rights reserved.
 * 
 * Parsing: place-holder for future support for Yacc-generated parsers
 *=========================================================================*)

module Microsoft.FSharp.MLLib.Parsing

open Lexing

let parse_information = ref (None : Lexing.position Microsoft.FSharp.Primitives.ParserState.Provider option)
let set_parse_state x = parse_information := Some x
let get_parse_information () = 
  match !parse_information with 
  | Some x ->x
  | None -> failwith "You must generate your parser using the '--ml-compatibility' option or call 'Parsing.set_parse_state parseState' in each action before using functions from the Parsing module.  This is because the module uses global state which must be set up for use in each parsing action. Review the notes in the 'Parsing' module if you are using parsers on multiple threads."

let dummy_pos = {pos_fname="?"; pos_lnum= 1; pos_bol= 1; pos_cnum=0 }

let symbol_start_pos () = (get_parse_information()).GetLhsStartMark()
let symbol_end_pos () = (get_parse_information()).GetLhsEndMark()
let rhs_start_pos (n:int) = (get_parse_information()).GetRhsStartMark n
let rhs_end_pos (n:int) = (get_parse_information()).GetRhsEndMark n

exception Parse_error  = Microsoft.FSharp.Primitives.ParserState.RecoverableParseError
let parse_error s = (get_parse_information()).RaiseError()(failwith s : unit)

let symbol_start () = (symbol_start_pos()).pos_cnum
let symbol_end () = (symbol_end_pos()).pos_cnum
let rhs_start n = (rhs_start_pos n).pos_cnum
let rhs_end n = (rhs_end_pos n).pos_cnum

