(*==========================================================================
 * (c) Microsoft Corporation. All rights reserved 
 *
 *=========================================================================*)

module Microsoft.FSharp.MLLib.Printexc

let to_string (e:exn) = 
  match e with 
  | Failure s -> s
  | Invalid_argument s -> "invalid argument: "^s
  | Match_failure(s,n,m) -> "match failure, file '"^s^"', line "^string_of_int n^", column "^string_of_int m
  | _ -> any_to_string e^"\n"

let print f x = try f x with e -> prerr_endline (to_string e) ; raise e 
