(*==========================================================================
 * Strings: basic operations for ML compatibility
 *
 * (c) Microsoft Corporation 2004.  All code and documentation in this file 
 * has been written 'from scratch'.  The interface to the module 
 * is similar to that found in versions of other ML implementations, 
 * but is not an exact match.  The type signatures in this interface
 * are an edited version of those generated automatically by running 
 * "bin\fsc.exe -i" on the implementation file.
 *=========================================================================*)

module Microsoft.FSharp.MLLib.String

val capitalize: string -> string
val compare: string -> string -> int
val concat: string -> string list -> string
val contains: string -> char -> bool
val contains_between: string -> int -> int -> char -> bool
val contains_from: string -> int -> char -> bool
val get: string -> int -> char
val index: string -> char -> int
val index_from: string -> int -> char -> int

///Apply the given function to each character in the string
val iter: (char -> unit) -> string -> unit
val length: string -> int
val lowercase: string -> string
val make: int -> char -> string
val of_char: char -> string
val rcontains_from: string -> int -> char -> bool
val rindex: string -> char -> int
val rindex_from: string -> int -> char -> int
val sub: string -> int -> int -> string
val uncapitalize: string -> string
val uppercase: string -> string
(* note: string values are immutable *)
