open System
open System.Windows.Forms

let form = new Form()
do form.Width  <- 400
do form.Height <- 300
do form.Text <- "Hello World Form"

(* Menu bar, menus *)
let mMain = form.Menu <- new MainMenu()
let mFile = form.Menu.MenuItems.Add("&File")
let miQuit  = new MenuItem("&Quit")
let _ = mFile.MenuItems.Add(miQuit)

(* RichTextView *)
let textB = new RichTextBox()
do textB.Dock <- DockStyle.Fill  
do textB.Text <- "Hello World\n\nOK."
do form.Controls.Add(textB)    

(* callbacks *)
do miQuit.add_Click (new EventHandler(fun _ _ -> form.Close()))

// Run the main code. The attribute marks the startup application thread as "Single 
// Thread Appartment" mode, which is necessary for GUI applications. 
[<STAThread>]    
do Application.Run(form)
